package Kitten::Create;

use strict;
use warnings;
use base 'Kitten';

use Kitten::RSS;

sub setup {
    my $self = shift;
    $self->start_mode('create');
    $self->error_mode('do_error');
    $self->run_modes(
        'create'      => \&do_create,
        'disp_create' => \&do_disp_create,
    );
}

sub do_create {
    my $self = shift;

    unless ( $self->session->param('login') ){
        $self->log->info('Not Logged in');
        die;
    }

    my $q = $self->query;

    if ( $q->param('title') eq '' ||
         $q->param('memo')  eq '' ||
         $q->param('tags')  eq ''
       )
    {
        return $self->forward('disp_create');
    }

    Kitten::Strage::DBIC::Schema->memo_create($self);

    Kitten::RSS->new->create_rss($self);

    return $self->redirect(
         $self->config_param->{Domain}->{path}
        .'/'
        .$self->config_param->{Trigger}->{name}
        .'/page?id='
        .$self->stash->{'last_insert_id'}
    );
}

sub do_disp_create {
    shift->tt_process('create.tt');
}

1;
