package Kitten::Edit;

use strict;
use warnings;
use base 'Kitten';

sub setup {
    my $self = shift;
    $self->start_mode('edit');
    $self->error_mode('do_error');
    $self->run_modes(
        'edit'      => \&do_edit,
        'disp_edit' => \&do_disp_edit,
    );
}

sub do_edit {
    my $self = shift;

    unless ( $self->session->param('login') ){
        $self->log->info('Not Logged in');
        die;
    }

    my $q = $self->query;
    if ( $q->param('title') eq '' &&
         $q->param('memo')  eq '' &&
         $q->param('tags')  eq ''
       )
    {
        return $self->forward('disp_edit');
    }

    Kitten::Strage::DBIC::Schema->memo_edit($self);

    return $self->redirect(
         $self->config_param->{Domain}->{path}
        .'/'
        .$self->config_param->{Trigger}->{name}
        .'/page?id='
        .$q->param('id')
    );
}

sub do_disp_edit {
    my $self = shift;

    Kitten::Strage::DBIC::Schema->memo_get($self);

    return $self->tt_process('edit.tt');
}

1;
