package Kitten::Login;

use strict;
use warnings;
use base 'Kitten';

sub setup {
    my $self = shift;
    $self->start_mode('login');
    $self->error_mode('do_error');
    $self->run_modes(
        'login'      => \&do_login,
        'disp_login' => \&do_disp_login,
    );
}

sub do_login {
    my $self = shift;
    my $q = $self->query;

    if ( $self->session->param('login') ){
        return $self->redirect(
             $self->config_param->{Domain}->{path}
            .'/'
            .$self->config_param->{Trigger}->{name}
            .'/create'
        );
    }

    if ( $q->param('user')   !~ /^[a-zA-Z0-9]+$/ ||
         $q->param('passwd') !~ /^[a-zA-Z0-9]+$/
       )
    {
        return $self->forward('disp_login');
    }

    my $count = Kitten::Strage::DBIC::Schema->user_get($self);

    return $self->forward('disp_login') unless ($count || $count != 0);

    $self->session->param(-name => 'login', -value => $count);

    return $self->redirect(
         $self->config_param->{Domain}->{path}
        .'/'
        .$self->config_param->{Trigger}->{name}
    );
}

sub do_disp_login {
    shift->tt_process('login.tt');
}

1;

