package Kitten::RSS;

use strict;
use warnings;
use XML::FeedPP;
use base qw(Class::Accessor::Fast);

__PACKAGE__->mk_accessors(qw/rss_engine/);

sub create_rss {
    my $self = shift;
    my $cap  = shift;

    if ( -f $cap->config_param->{RSS}->{name}  ) {
        $self->rss_engine( XML::FeedPP::RSS->new( $cap->config_param->{RSS}->{name} ) );
    }
    else {
        $self->rss_engine( XML::FeedPP::RSS->new );
        $self->rss_engine->title( $cap->config_param->{RSS}->{title} );
        $self->rss_engine->description( $cap->config_param->{RSS}->{description} );
        $self->rss_engine->pubDate( time );
        $self->rss_engine->copyright( $cap->config_param->{Template}->{copyright} );
        $self->rss_engine->link( $cap->config_param->{Domain}->{path}.'/'.$cap->config_param->{Trriger}->{name} );
        $self->rss_engine->language( 'ja' );
        $self->rss_engine->image( $cap->config_param->{Domain}->{path}.$cap->config_param->{RSS}->{image} );
    }

    my $c = ( $self->rss_engine->get_item() );

    if ( $c >= $cap->config_param->{RSS}->{max}  ) {

        my $new_rss = XML::FeedPP::RSS->new;
        $new_rss->title( $cap->config_param->{RSS}->{title} );
        $new_rss->description( $cap->config_param->{RSS}->{description} );
        $new_rss->pubDate( time );
        $new_rss->copyright( $cap->config_param->{Template}->{copyright} );
        $new_rss->link( $cap->config_param->{Domain}->{path}.'/'.$cap->config_param->{Trriger}->{name} );
        $new_rss->language( 'ja' );
        $new_rss->image( $cap->config_param->{RSS}->{image} );

        my $i=0;
        for my $item ( $self->rss_engine->get_item ) {
            if ( $i == 0 ) {
                $i++;
                next;
            }
            my $old_item = $new_rss->add_item( $item->link  );
            $old_item->title( $item->title );
            $old_item->pubDate( $item->pubDate );
            $old_item->description( $item->description );
            $i++;
        }
        $self->rss_engine($new_rss);
    }

    my $link =
         $cap->config_param->{Domain}->{path}
        .'/'
        .$cap->config_param->{Trigger}->{name}
        .'/page?id='
        .$cap->stash->{last_insert_id};

    my $new_item = $self->rss_engine->add_item( $link );
    my $q = $cap->query;
    $new_item->title( $q->param('title')  );
    $new_item->description( $q->param('memo') );
    $new_item->pubDate( time );
    $new_item->category( $q->param('tags') );
    $new_item->link( $link );

    $self->rss_engine->to_file( $cap->config_param->{RSS}->{name},'UTF-8' );

    return;
}

1;
