package Kitten::Search;

use strict;
use warnings;
use base 'Kitten';

sub setup {
    my $self = shift;
    $self->start_mode('search');
    $self->error_mode('do_error');
    $self->run_modes(
        'search'      => \&do_search,
        'disp_search' => \&do_disp_search,
    );
}

sub do_search {
    my $self = shift;
    my $q = $self->query;

    if ( $q->param('memo') ne '' ) {
        Kitten::Strage::DBIC::Schema->memo_search($self);
    }
    elsif ( $q->param('tags') ne '' ) {
        Kitten::Strage::DBIC::Schema->tags_search($self);
    }
    else {
        return $self->forward('disp_search');
    }

    return $self->tt_process('search.tt');
}

sub do_disp_search {
    shift->tt_process('disp_search.tt');
}

1;
